/* ----------------------- example.c -------------------------------- */

#include <stdio.h>
#include "toolset.h"
#if COMPILER != CWARE
#include <ctype.h>
#endif
#include "screen.h"
#include "file.h"
#include "btree.h"
#include "member.h"
#include "terminal.h"
#include "keys.h"

struct mbr_rcd mbr_data;							/* member.dat record */

char d_city [] = "                              ";	/* ditto areas */
char d_st   [] = "  ";
char d_zip  [] = "     ";

int mbr_ty_edit();
int mbr_edit();
char *mbr_help();

struct scrn_buf mbr [] = {
 { 'Z', FALSE, mbr_data.mbr_no, mbr_edit,    mbr_help, TRUE,  FALSE, 0	    },
 { 'A', FALSE, mbr_data.mbr_nm, 0,           0,        TRUE,  FALSE, 0      },
 { 'A', FALSE, mbr_data.addr1,  0,           0,        TRUE,  FALSE, 0      },
 { 'A', FALSE, mbr_data.addr2,  0,           0,        TRUE,  FALSE, 0      },
 { 'A', FALSE, mbr_data.city,   0,           0,        TRUE,  FALSE, d_city },
 { 'A', FALSE, mbr_data.state,  0,           0,        TRUE,  FALSE, d_st   },
 { 'N', FALSE, mbr_data.zip,    0,	     	 0,        TRUE,  FALSE, d_zip  },
 { 'N', FALSE, mbr_data.phone,  0,           0,        TRUE,  FALSE, 0      },
 { 'C', FALSE, mbr_data.dues,   0,	     	 0,	       TRUE,  FALSE, 0      },
 { 'A', FALSE, mbr_data.mbr_ty, mbr_ty_edit, 0,        TRUE,  FALSE, 0      },
 { 'D', FALSE, mbr_data.exp_dt, 0, 	     	 0,        TRUE,  FALSE, 0      }
};

int existing_record = FALSE;			/* flag */
ADDR adr = 0;							/* current record address */
int mbr_file;							/* member.dat fd */
struct mbr_rcd hold_rcd;				/* hold area for member.dat record */
VOID get_rcd(), rtn_rcd(), gt_nxt(), clr_rcd(), gt_prv();
int tree;

/*page*/

main()
{
	static char term = '\0', c;

	setmem(&mbr_data, sizeof mbr_data, '\0');
	tree = init_b("mbrno.ndx", 5);
	read_screens("video.crt");
	if ((mbr_file = opn_file("members.dat", 0)) == ERROR)
		mbr_file = opn_file("members.dat", sizeof(mbr_data));
	clr_rcd();
	while (term != ESC)	 	{
		term = scrn_proc(1, mbr, FALSE);
		switch (term)		{
			case  F10:			/* --- Next Record --- */
				rtn_rcd();
				gt_nxt();
				break;
			case F9:			/* --- Previous Record --- */
				rtn_rcd();
				gt_prv();
				break;
			case F7:			/* --- Delete Record --- */
				if (existing_record)	{
					err_msg("Verify delete with F7");
					if ((c = get_byte()) == F7)	{
						delete_record(mbr_file, adr);
						delete_key(tree, hold_rcd.mbr_no, adr);
						clr_rcd();
						adr = 0;
						clrmsg();
					}
					else
						notice("Delete cancelled     ");
				}
				break;
			case GO:			/*-- Write Record --*/
				rtn_rcd();
				clr_rcd();
				break;
			}
	}
	clr_scrn();
	close_b(tree);
	cls_file(mbr_file);
	reset_screens();
	exit(0);
}

/*page*/

/* ------ called when member number is entered ------ */

int mbr_edit(mno,ky)
char *mno, ky;
{
	register int i;

	if (ky == ESC || ky == F9 || ky == F10 || ky == F7 || ky == GO)
		return OK;
	if (*mno == ' ')	{
		err_msg("Membership number required");
		return ERROR;
	}
	if (find_key(tree, mno, &adr))	{
		get_rcd();
		for (i = 1; i <= 10; i++)
			backfill(1, i, mbr);
	}
	else	{
		notice("New record being added");
		existing_record = FALSE;
	}
	return OK;
}

/*page*/

/* ----- return a record to the file or create a new one ----- */

VOID rtn_rcd()
{
	int i = sizeof(mbr_data);
	register char *s = mbr_data.mbr_no;
	register char *d = hold_rcd.mbr_no;

	if (existing_record)	{
		while (i)					/* test for record changed */
			if (*s++ != *d++)
				break;
			else
				i--;
		if (!i)
			return;
		notice("Changed record written to file");
		put_record(mbr_file, adr, &mbr_data);
	}
	else	{
		while (i)					/* test for any data in rcd */
			if (*s == ' ' || *s == '\0')	{
				s++;
				i--;
			}
			else
				break;
		if (!i)
			return;
		notice("New record written to file");
		adr = new_record(mbr_file, &mbr_data);
		insert_key(tree,mbr_data.mbr_no,adr,TRUE);
	}

/* ----- save the new record in the hold area ----- */

	movmem(&mbr_data, &hold_rcd, sizeof(mbr_data));
}

/*page*/

/* ----- clear the record space ----- */

VOID clr_rcd()
{
	existing_record = FALSE;
	setmem(&mbr_data, sizeof(mbr_data), ' ');
	setmem(&hold_rcd, sizeof(mbr_data), ' ');
	mbr [0].protect = FALSE;
}

/* ------ get a record from the file ------ */

VOID get_rcd()
{
	existing_record = TRUE;
	get_record(mbr_file, adr, &mbr_data);
	movmem(&mbr_data, &hold_rcd, sizeof(mbr_data));
	mbr [0].protect = TRUE;
}

/* ----- get the next record from the file ----- */

VOID gt_nxt()
{
	ADDR ad;

	clrmsg();
	if ((ad = get_next(tree)) == (ADDR) NULL)
		notice("End of file");
	else	{
		adr = ad;
		get_rcd();
	}
}

/* ----- get the previous record from the file ----- */

VOID gt_prv()
{
	ADDR ad;

	clrmsg();
	if ((ad = get_prev(tree)) == (ADDR) NULL)
		notice("Beginning of file");
	else	{
		adr = ad;
		get_rcd();
	}
}

/*page*/

/* ------ help function for the membership number ------ */

char *mbr_help()
{
	notice("Enter the membership number of the member");
	return "\0";
}

/* ------ edit the membership type ------ */

int mbr_ty_edit(ty,ky)
char *ty, ky;
{
	*ty = toupper(*ty);
	switch (*ty)	{
		case ' ':
		case 'A':
		case 'L':
		case 'S':
			return OK;
		default:
			err_msg("Invalid Membership Type");
			return ERROR;
	}
}
